﻿<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:ms="urn:schemas-microsoft-com:xslt"
xmlns:vb="urn:the-xml-files:xslt-vb">
<ms:script language="VBScript" implements-prefix="vb">
    <![CDATA[
	'Copyright (c) 2001-2004 Alexander Fedorenko. All Rights Reserved.
	'Do not modify this code. Use separate include instead.
	Dim gAllWorkingHours, gAllEstimations
	gAllWorkingHours = 0.0
	gAllEstimations = 0.0
	
	Dim gAllWorkingHoursForCompleted, gAllEstimationsForCompleted
	gAllWorkingHoursForCompleted = 0.0
	gAllEstimationsForCompleted = 0.0
	
	Dim gMaxEffortError, gMinEffortError
	gMaxEffortError = ""
	gMinEffortError = ""
	
	Function PushHours(workingHours, estimation, status)
		If workingHours <> "" Then
			gAllWorkingHours = gAllWorkingHours + CDbl(workingHours)
		End If
		If estimation <> "" Then
			gAllEstimations = gAllEstimations + CDbl(estimation)
		End If
		
		If status = "2" Then
			If workingHours <> "" Then
				gAllWorkingHoursForCompleted = gAllWorkingHoursForCompleted + CDbl(workingHours)
			End If
			If estimation <> "" Then
				gAllEstimationsForCompleted = gAllEstimationsForCompleted + CDbl(estimation)
			End If

			If CDbl(workingHours) <> 0 And CDbl(estimation) <> 0 Then
				Dim effortError
				effortError = (CDbl(workingHours) - CDbl(estimation)) / CDbl(estimation) * 100
				If gMaxEffortError = "" Or gMaxEffortError < effortError Then
					gMaxEffortError = effortError
				End If
				If gMinEffortError = "" Or gMinEffortError > effortError Then
					gMinEffortError = effortError
				End If
			End If
		End If
		PushHours = ""
	End Function
	
	Function GetAllWorkingHours()
		GetAllWorkingHours = gAllWorkingHours
	End Function
	
	Function GetEstimationError()
		If (gAllEstimationsForCompleted <> 0) Then
			GetEstimationError = _
				Round((gAllWorkingHoursForCompleted - gAllEstimationsForCompleted)/gAllEstimationsForCompleted*100)
		Else
			GetEstimationError = ""
		End If
	End Function

	Function GetEffortErrorMin()
		GetEffortErrorMin = ""
		If gMinEffortError <> "" Then
			GetEffortErrorMin = Round(gMinEffortError)
		End If
	End Function

	Function GetEffortErrorMax()
		GetEffortErrorMax = ""
		If gMaxEffortError <> "" Then 
			GetEffortErrorMax = Round(gMaxEffortError)
		End If
	End Function

	Function GetPresence()
		GetPresence = ""
		If (GetLastEntryDateInCategory() <> "") And (GetAllWorkingHours() <> 0) _
			And (GetFirstEntryDateInCategory() <> "") Then
			Dim presence
			presence = GetWorkingDaysNumber() * GetRegularHours() / GetAllWorkingHours()
			If presence > 0 Then
				GetPresence = Round(100 / presence)
			End If
		End If
	End Function

	Function CalculateOverSpend(originalEstimates, stageWorkingHours)
		CalculateOverSpend = 100
		If originalEstimates > 0 Then
			CalculateOverSpend = Round((stageWorkingHours-originalEstimates)/originalEstimates*100)
		End If
	End Function

	Function CalculateOverSpendFromUnplanned(originalEstimates, stageWorkingHours, plannedWorkingHours)
		If originalEstimates > 0 Then
			If CDbl(originalEstimates) < CDbl(stageWorkingHours) Then
				If CDbl(originalEstimates) < CDbl(plannedWorkingHours) Then
					CalculateOverSpendFromUnplanned = Round( _
						(stageWorkingHours-plannedWorkingHours)/ _
						(originalEstimates*(stageWorkingHours/originalEstimates-1))*100)
				Else
					CalculateOverSpendFromUnplanned = 100
				End If
			Else
				CalculateOverSpendFromUnplanned = 0
			End If
		Else
			CalculateOverSpendFromUnplanned = 100
		End If
	End Function
    ]]>
</ms:script>

</xsl:stylesheet>
  