<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:ms="urn:schemas-microsoft-com:xslt" xmlns:vb="urn:the-xml-files:xslt-vb">
	<ms:script language="VBScript" implements-prefix="vb"><![CDATA[
	'Copyright (c) 2001-2004 Alexander Fedorenko. All Rights Reserved.
	'Do not modify this code. Use separate include instead.
	Dim gAutoNumber
	Function NextNumber(id)
		gAutoNumber = gAutoNumber + 1
		NextNumber = gAutoNumber
	End Function
	
	Function GetImportanceString(importanceNodesList)
		Dim importance, importanceString
		importance = importanceNodesList.item(0).nodeValue
		Select Case importance
			Case "0" importanceString = "{UrgentAndImportant}"
			Case "1" importanceString = "{Important}"
			Case "2" importanceString = "{Urgent}"
			Case "3" importanceString = "{FutureTask}"
		End Select
		GetImportanceString = importanceString
    End Function
    
	Function GetStatusString(statusNodesList)
		Dim status, statusString
		status = statusNodesList.item(0).nodeValue
		statusString = ""
		Select Case status
			Case "0" statusString = "{New}"
			Case "1" statusString = "{InProgress}"
			Case "2" statusString = "{Completed}"
			Case "3" statusString = "{Deferred}"
		End Select
		GetStatusString = statusString
	End Function
	
    Function GetCurrentDate()
		GetCurrentDate = FormatDate(Date)
    End Function

    Function GetCurrentDateUdt()
		GetCurrentDateUdt = CLng(Date)
    End Function
    
	Function FormatDate(dateUTC)
		FormatDate = ""
		If Not IsDate(dateUTC) And dateUTC<>"" Then
			dateUTC = CDate(dateUTC)
		End If
		If IsDate(dateUTC) Then
			FormatDate = FormatDateTime(dateUTC, 2)
		End If
	End Function
	
	Function FormatNumberEx(value)
		FormatNumberEx = "" & Round(value, 1)
	End Function

	Function Substract(v1, v2)
		Substract = "0"
		If IsNumeric(v1) And IsNumeric(v2) Then
			Substract = FormatNumberEx(v1 - v2)

		End If
	End Function

	Function IsLess(node1, str2)
		Dim str1
		str1 = node1.item(0).nodeValue
		IsLess = (str1 < str2)
	End Function
	
	Function IsEqualDate(dateUdt, dateLong)
		IsEqualDate = (CDate(dateUdt) = CDate(dateLong))
	End Function
	
  Function IsBiggerDate(dateOfTast, dateToCompare)
		IsBiggerDate = (CDate(dateOfTast) >= CDate(dateToCompare))
	End Function
  
	Function GetMaxDate(datesList)
		Dim maxDate
		maxDate = 0
		Dim nEntries
		nEntries = datesList.length
		For i = 0 To nEntries-1
			Dim nextDate
			nextDate = CDate(datesList.item(i).nodeValue)
			If nextDate > maxDate Then
				maxDate = nextDate
			End If
		Next
		GetMaxDate = FormatDate(maxDate)
	End Function
	
	Function RestrictLength(text, maxLength)
		If Len(text) > maxLength Then
			RestrictLength = Left(text, maxLength) & " ..."
		Else
			RestrictLength = text
		End If
	End Function
	
	Dim gRegularHours
	gRegularHours = 8.0
	Function GetRegularHours()
		GetRegularHours = gRegularHours
	End Function
	
	Function SetRegularHours(hours)
		gRegularHours = hours
		SetRegularHours = ""
	End Function
    ]]></ms:script>
</xsl:stylesheet>
