﻿<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:ms="urn:schemas-microsoft-com:xslt"
xmlns:vb="urn:the-xml-files:xslt-vb">
<ms:script language="VBScript" implements-prefix="vb">
    <![CDATA[
	'Copyright (c) 2001-2004 Alexander Fedorenko. All Rights Reserved.
	'Do not modify this code. Use separate include instead.
	Function IsHoliday(examinedDate)
		Dim d
		d = CDate(examinedDate)
		If Weekday(d) = vbSunday Or Weekday(d) = vbSaturday Then
			IsHoliday = True
		Else
			IsHoliday = False
		End If
		
		If IsInverted(d) Then
			IsHoliday = Not IsHoliday
		End If
	End Function
	
	Dim gInvertedHolidays
	Function IsInverted(examinedDate)
		IsInverted = False
		If IsObject(gInvertedHolidays) Then
			For Each item In gInvertedHolidays
				If CDate(item.text) = examinedDate Then
					IsInverted = TRUE
				End If
			Next
		End If
	End Function
	
	Function PushHolidays(invertedHolidays)
		Set gInvertedHolidays = invertedHolidays
		PushHolidays = ""
	End Function
	
	Function GetWorkingDaysNumber()
		Dim lastDate
		lastDate = GetLastEntryDateInCategory()
		GetWorkingDaysNumber = GetWorkingDaysNumberUsingLast(lastDate)
	End Function

	Function GetWorkingDaysInHours(regularHours)
		GetWorkingDaysInHours = _
			Round(GetWorkingDaysNumber() * regularHours, 1)
	End Function

	Function GetWorkingDaysNumberCompleted()
		Dim lastDate
		lastDate = GetLastEntryDateCompletedInCategory()
		GetWorkingDaysNumberCompleted = GetWorkingDaysNumberUsingLast(lastDate)
	End Function
	
	Function GetWorkingDaysNumberUsingLast(lastDate)
		Dim firstDate
		firstDate = GetFirstEntryDateInCategory()
		If (lastDate <> "") And (firstDate <> "") Then
			Dim daysSpent
			daysSpent = 0
			Dim nextDate
			For nextDate = CDate(firstDate) To CDate(lastDate)
				If Not IsHoliday(nextDate) Then
					daysSpent = daysSpent + 1
				End If
			Next
			GetWorkingDaysNumberUsingLast = "" & daysSpent
		Else
			GetWorkingDaysNumberUsingLast = 0
		End If
	End Function
	
	Function GetWorkingDaysNumberInHoursCompleted()
		GetWorkingDaysNumberInHoursCompleted = GetWorkingDaysNumberCompleted() * 8
	End Function
    ]]>
</ms:script>
</xsl:stylesheet>
  