<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:ms="urn:schemas-microsoft-com:xslt"
xmlns:vb="urn:the-xml-files:xslt-vb">
<ms:script language="VBScript" implements-prefix="vb">
    <![CDATA[
	'Copyright (c) 2001-2004 Alexander Fedorenko. All Rights Reserved.
	'Do not modify this code. Use separate include instead.
	Option Explicit

	Dim gFirstEntryStart, gLastEntryEnd
	Function SetFirstEntryStart(startTime)
		gFirstEntryStart = startTime
		SetFirstEntryStart = ""
	End Function

	Function SetLastEntryEnd(endTime)
		gLastEntryEnd = endTime
		SetLastEntryEnd = ""
	End Function

	Dim gMealStart, gMealEnd
	Function SetMealStart(startTime)
		gMealStart = startTime
		SetMealStart = ""
	End Function

	Function SetMealEnd(endTime)
		gMealEnd = endTime
		SetMealEnd = ""
	End Function

	Dim gSickEnd, gSickStart
	Function SetSickEnd(endTime)
		gSickEnd = endTime
		SetSickEnd = ""
	End Function

	Function SetSickStart(startTime)
		gSickStart = startTime
		SetSickStart = ""
	End Function

	Dim gVacationStart, gVacationEnd
	Function SetVacationStart(startTime)
		gVacationStart = startTime
		SetVacationStart = ""
	End Function

	Function SetVacationEnd(endTime)
		gVacationEnd = endTime
		SetVacationEnd = ""
	End Function

	Function IsVacationOrSick()
		IsVacationOrSick = ((gSickStart = gFirstEntryStart) _
			And (gSickEnd = gLastEntryEnd)) _
			Or ((gVacationStart = gFirstEntryStart) _
			And (gVacationEnd = gLastEntryEnd))
	End Function

	Function GetFirstTimeIn()
		Dim out
		If IsVacationOrSick() Then
			out = ""
		ElseIf gSickStart = gFirstEntryStart Then
      If gMealStart = gSickEnd Then
        out = ""
      Else
			  out = gSickEnd
      End If
		ElseIf gVacationStart = gFirstEntryStart Then
			out = gVacationEnd
		Else
			out = gFirstEntryStart
		End If
		
		GetFirstTimeIn = FormatTime(out)
	End Function

	Function GetFirstTimeOut()
		Dim out
		'If GetFirstTimeIn() = "" Then
		'	out = ""
		'Else
    If gMealStart <> "" Then
			out = gMealStart
		ElseIf gLastEntryEnd = gSickEnd Then
			out = gSickStart
		ElseIf gLastEntryEnd = gVacationEnd Then
			out = gVacationStart
		Else
			out = gLastEntryEnd
		End If
		
		GetFirstTimeOut = FormatTime(out)
	End Function

	Function GetSecondTimeIn()
		Dim out
		If GetFirstTimeOut() = "" Then
			out = ""
		ElseIf gMealEnd <> "" Then
			out = gMealEnd
		Else
			out = ""
		End If
		
		GetSecondTimeIn = FormatTime(out)
	End Function

	Function GetSecondTimeOut()
		Dim out
		If GetSecondTimeIn() = "" Then
			out = ""
		Else
			out = gLastEntryEnd
		End If
		
		GetSecondTimeOut = FormatTime(out)
	End Function

	Function Diff(t1start, t1end)
		Dim total
		If IsDate(t1start) And IsDate(t1end) Then
			total = CDate(t1end) - CDate(t1start)
		End If
		Diff = total * 24
	End Function
	
	Function FormatHours(value)
		FormatHours = FormatNumberEx(value)
	End Function
	
	Dim gIs24HoursFormat
	gIs24HoursFormat = True
	Function SetTimeFormat(is24hours)
		gIs24HoursFormat = is24hours
		SetTimeFormat = ""
	End Function
	
	Function Is24HoursFormat()
		Is24HoursFormat = gIs24HoursFormat
	End Function
	
	const nHalfDay = 12
	
	Function GetAs12Hours(nHours)
		If nHours > nHalfDay Then
			GetAs12Hours = nHours - nHalfDay
		Else
			GetAs12Hours = nHours
		End If
	End Function
	
	Function GetAmPm(nHours)
		If nHours >= nHalfDay Then
			GetAmPm = "PM"
		Else
			GetAmPm = "AM"
		End If
	End Function
	
	Function GetAsTwoDigits(iNumber)
		Dim strLeading
		strLeading = ""
		If iNumber < 10 Then
			strLeading = "0"
		End If
		GetAsTwoDigits = strLeading & iNumber
	End Function
	
	Function FormatTime(strTime)
		Dim fmt
		fmt = ""
		If strTime <> "" Then
			Dim nHours, nMinutes
			nHours = Hour(strTime)
			nMinutes = Minute(strTime)
			If Is24HoursFormat() Then
				fmt = nHours & ":" & GetAsTwoDigits(nMinutes)
			Else
				fmt = GetAs12Hours(nHours) & ":" & GetAsTwoDigits(nMinutes) _
					& Chr(160) & GetAmPm(nHours)
			End If
		End If
		FormatTime = fmt
	End Function
	
	Function GetTotalHours()
		Dim total
		total = Diff(GetFirstTimeIn(), GetFirstTimeOut())
		total = total + Diff(GetSecondTimeIn(), GetSecondTimeOut())
    If total > 0 Then
			GetTotalHours = FormatHours(total)
		Else
			GetTotalHours = ""
		End If
	End Function

	Function GetRegularHoursWorked()
		If GetTotalHours() <> "" Then
			If CDbl(GetTotalHours()) > gRegularHours Then 
				GetRegularHoursWorked = gRegularHours
			Else
				GetRegularHoursWorked = GetTotalHours()
			End If
		Else
			GetRegularHoursWorked = ""
		End If
		AddRegularHours GetRegularHoursWorked
	End Function

	Function GetOvertime()
		GetOvertime = ""
		If GetTotalHours() <> "" Then
			If CDbl(GetTotalHours()) > gRegularHours Then 
				GetOvertime = FormatHours(GetTotalHours() - gRegularHours)
			End If
		End If
		AddOvertime GetOvertime
	End Function

	Function GetSickHours()
		If gSickEnd <> "" And gSickStart <> "" Then
			GetSickHours = FormatHours(Diff(gSickStart, gSickEnd))
		Else
			GetSickHours = ""
		End If
		AddSickHours GetSickHours
	End Function

	Function GetVacationHours()
		If gVacationStart <> "" And gVacationEnd <> "" Then
			GetVacationHours = _
				FormatHours(Diff(gVacationStart, gVacationEnd))
		Else
			GetVacationHours = ""
		End If
		AddVacationHours GetVacationHours
	End Function
	
	Dim gRegularHoursTotal, gOvertimeTotal, _
		gSickHoursTotal, gVacationHoursTotal
	gRegularHoursTotal = 0.0
	gOvertimeTotal = 0.0
	gSickHoursTotal = 0.0
	gVacationHoursTotal = 0.0
	
	Sub AddRegularHours(hours)
		If hours <> "" Then
			gRegularHoursTotal = gRegularHoursTotal + hours
		End If
	End Sub
	
	Sub AddOvertime(hours)
		If hours <> "" Then
			gOvertimeTotal = gOvertimeTotal + hours
		End If
	End Sub
	
	Sub AddSickHours(hours)
		If hours <> "" Then
			gSickHoursTotal = gSickHoursTotal + hours
		End If
	End Sub
	
	Sub AddVacationHours(hours)
		If hours <> "" Then
			gVacationHoursTotal = gVacationHoursTotal + hours
		End If
	End Sub
	
	Function GetRegularHoursTotal()
		GetRegularHoursTotal = ""
		If gRegularHoursTotal > 0 Then
			GetRegularHoursTotal = FormatHours(gRegularHoursTotal)
		End If
	End Function 
	
	Function GetOvertimeTotal()
		GetOvertimeTotal = ""
		If gOvertimeTotal > 0 Then
			GetOvertimeTotal = FormatHours(gOvertimeTotal)
		End If
	End Function 
	
	Function GetSickHoursTotal()
		GetSickHoursTotal = ""
		If gSickHoursTotal > 0 Then
			GetSickHoursTotal = FormatHours(gSickHoursTotal)
		End If
	End Function 
	
	Function GetVacationHoursTotal()
		GetVacationHoursTotal = ""
		If gVacationHoursTotal > 0 Then
			GetVacationHoursTotal = FormatHours(gVacationHoursTotal)
		End If
	End Function 
    ]]>
</ms:script>

</xsl:stylesheet>
  